using FalcoEngine;

public class BlockManager : MonoBehaviour
{
	public string orientation = "h";
	public int len = 2;
    public Vector3 mouseStartPos;
    public bool moving = false;
    public Prefab col;

    private bool choosen = false;
	private MouseManager mouse;

	void Start()
	{
		mouse = FindObjectOfType<MouseManager>();
	}

	public void Choose()
	{
		choosen = true;
		mouseStartPos = mouse.GetGlobalMousePosition();
	}

	void ChoosenUpdate()
	{
		Vector3 currentMousePos = mouse.GetGlobalMousePosition();

		if (orientation == "h")
		{
			if (currentMousePos.x + 1f <= mouseStartPos.x) 
			{
                Col c = col.Instantiate(transform.position - new Vector3(1f * len, 0f, 0f)).GetComponent<Col>();
                c.block = gameObject.GetComponent<BlockManager>();
                c.moveBy = new Vector3(-1f, 0f, 0f);
                moving = true;
            }
            if (currentMousePos.x - 1f >= mouseStartPos.x)
            {
                Col c = col.Instantiate(transform.position + new Vector3(0.75f, 0f, 0f)).GetComponent<Col>();
                c.block = gameObject.GetComponent<BlockManager>();
                c.moveBy = new Vector3(1f, 0f, 0f);
                moving = true;
            }
        }
		else
		{
            if (currentMousePos.y + 1f <= mouseStartPos.y)
            {
                Col c = col.Instantiate(transform.position - new Vector3(0f, 0.75f, 0f)).GetComponent<Col>();
                c.block = gameObject.GetComponent<BlockManager>();
                c.moveBy = new Vector3(0f, -1f, 0f);
                moving = true;
            }
            if (currentMousePos.y - 1f >= mouseStartPos.y)
            {
                Col c = col.Instantiate(transform.position + new Vector3(0f, 1f * len, 0f)).GetComponent<Col>();
                c.block = gameObject.GetComponent<BlockManager>();
                c.moveBy = new Vector3(0f, 1f, 0f);
                moving = true;
            }
        }
	}
	
	void Update()
	{
		if (choosen)
		{
			if (Input.GetMouseButtonUp(0))
				choosen = false;
			else
				if (!moving)
					ChoosenUpdate();
		}
	}
}
