using FalcoEngine;

public class AppControls : MonoBehaviour
{
    private MouseControls mouse;
    private StatsManager stats;

    void Start()
    {
        stats = FindObjectOfType<StatsManager>();
        mouse = FindObjectOfType<MouseControls>();
        Cursor.visible = false;
    }

    void Update()
    {
        if (Input.GetKeyDown(ScanCode.Escape))
            Application.Quit();

        if (Input.GetMouseButtonDown(0))
        {
            if (stats.status == "p")
                mouse.Click();
        }
    }
}
