using FalcoEngine;
using System.Text.RegularExpressions;
using System;

public class StatsManager : MonoBehaviour
{
    public Prefab nextLevelSphere;

    public string status = "p";
	public int currentLevel;

    private float nextLevelTimer = 0f;

    public void MoveToNextLevel()
    {
        SceneManager.LoadScene($"{currentLevel + 1}.scene");
    }

    public void RestartLevel()
    {
        SceneManager.LoadScene($"{currentLevel}.scene");
    }

    void Start()
    {
        currentLevel = Convert.ToInt32(Regex.Replace(SceneManager.loadedScene, @"[^\d]+", ""));
    }

    void StatsCast()
    {
        if (status == "f")
        {
            status = "f1";
            nextLevelSphere.Instantiate();
        }
        if (status == "f1")
        {
            if (currentLevel != 10)
            {
                nextLevelTimer += 1f * Time.deltaTime;
                if (nextLevelTimer >= 2f)
                    MoveToNextLevel();
            }
        }
    }

    void Update()
    {
        StatsCast();
    }
}
